> ## Documentation Index
> Fetch the complete documentation index at: https://docs.3ngram.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Inspect memory lineage, direct relationships, and audit metadata



## OpenAPI

````yaml /api-reference/openapi.json get /api/v1/memories/{id}/history
openapi: 3.1.0
info:
  description: >-
    The /api/v1 REST mirror of the 3ngram memory core
    (docs/concepts/architecture.mdx: one core, N transports). Authenticate with
    an X-API-Key header or a session Bearer token.
  title: 3ngram REST API
  version: v1
servers:
  - description: 3ngram platform
    url: https://api.3ngram.ai
security:
  - apiKey: []
  - sessionBearer: []
paths:
  /api/v1/memories/{id}/history:
    get:
      summary: Inspect memory lineage, direct relationships, and audit metadata
      operationId: getMemoryHistory
      parameters:
        - in: path
          name: id
          required: true
          schema:
            format: uuid
            pattern: >-
              ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                additionalProperties: false
                properties:
                  auditEvents:
                    items:
                      additionalProperties: false
                      properties:
                        actorKind:
                          enum:
                            - user_dashboard
                            - user_api
                            - user_mcp
                            - worker
                            - importer
                            - system
                          type: string
                        createdAt:
                          format: date-time
                          pattern: >-
                            ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                          type: string
                        eventKind:
                          enum:
                            - create
                            - revise
                            - supersede
                            - resolve
                            - unresolve
                            - archive
                            - import
                            - embed_failed
                          type: string
                        id:
                          format: uuid
                          pattern: >-
                            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                          type: string
                        payloadMetadata:
                          additionalProperties: false
                          properties:
                            byteLength:
                              maximum: 9007199254740991
                              minimum: 0
                              type: integer
                            jsonType:
                              anyOf:
                                - enum:
                                    - object
                                    - array
                                    - string
                                    - number
                                    - boolean
                                    - 'null'
                                  type: string
                                - type: 'null'
                            present:
                              type: boolean
                          required:
                            - present
                            - jsonType
                            - byteLength
                          type: object
                      required:
                        - id
                        - eventKind
                        - actorKind
                        - createdAt
                        - payloadMetadata
                      type: object
                    type: array
                  directRelationships:
                    additionalProperties: false
                    properties:
                      predecessors:
                        items:
                          additionalProperties: false
                          properties:
                            edge:
                              additionalProperties: false
                              properties:
                                createdAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                createdBy:
                                  enum:
                                    - user_dashboard
                                    - user_api
                                    - user_mcp
                                    - worker
                                    - importer
                                    - system
                                  type: string
                                edgeType:
                                  enum:
                                    - supersedes
                                    - updates
                                    - extends
                                    - derives
                                  type: string
                                fromId:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                id:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                toId:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                              required:
                                - id
                                - fromId
                                - toId
                                - edgeType
                                - createdBy
                                - createdAt
                              type: object
                            memory:
                              additionalProperties: false
                              properties:
                                createdAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                id:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                isCurrent:
                                  type: boolean
                                lifecycleState:
                                  enum:
                                    - current
                                    - superseded
                                    - archived
                                    - historical
                                  type: string
                                memoryType:
                                  enum:
                                    - decision
                                    - commitment
                                    - blocker
                                    - fact
                                    - preference
                                    - pattern
                                    - note
                                    - event
                                  type: string
                                project:
                                  anyOf:
                                    - maxLength: 256
                                      minLength: 1
                                      type: string
                                    - type: 'null'
                                recordedAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                scope:
                                  maxLength: 64
                                  minLength: 1
                                  pattern: ^[a-z0-9][a-z0-9-]*$
                                  type: string
                                status:
                                  enum:
                                    - active
                                    - archived
                                  type: string
                                topic:
                                  type: string
                                validFrom:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                validTo:
                                  anyOf:
                                    - format: date-time
                                      pattern: >-
                                        ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                      type: string
                                    - type: 'null'
                              required:
                                - id
                                - memoryType
                                - topic
                                - project
                                - scope
                                - status
                                - validFrom
                                - validTo
                                - recordedAt
                                - createdAt
                                - isCurrent
                                - lifecycleState
                              type: object
                          required:
                            - memory
                            - edge
                          type: object
                        type: array
                      successors:
                        items:
                          additionalProperties: false
                          properties:
                            edge:
                              additionalProperties: false
                              properties:
                                createdAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                createdBy:
                                  enum:
                                    - user_dashboard
                                    - user_api
                                    - user_mcp
                                    - worker
                                    - importer
                                    - system
                                  type: string
                                edgeType:
                                  enum:
                                    - supersedes
                                    - updates
                                    - extends
                                    - derives
                                  type: string
                                fromId:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                id:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                toId:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                              required:
                                - id
                                - fromId
                                - toId
                                - edgeType
                                - createdBy
                                - createdAt
                              type: object
                            memory:
                              additionalProperties: false
                              properties:
                                createdAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                id:
                                  format: uuid
                                  pattern: >-
                                    ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                                  type: string
                                isCurrent:
                                  type: boolean
                                lifecycleState:
                                  enum:
                                    - current
                                    - superseded
                                    - archived
                                    - historical
                                  type: string
                                memoryType:
                                  enum:
                                    - decision
                                    - commitment
                                    - blocker
                                    - fact
                                    - preference
                                    - pattern
                                    - note
                                    - event
                                  type: string
                                project:
                                  anyOf:
                                    - maxLength: 256
                                      minLength: 1
                                      type: string
                                    - type: 'null'
                                recordedAt:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                scope:
                                  maxLength: 64
                                  minLength: 1
                                  pattern: ^[a-z0-9][a-z0-9-]*$
                                  type: string
                                status:
                                  enum:
                                    - active
                                    - archived
                                  type: string
                                topic:
                                  type: string
                                validFrom:
                                  format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                validTo:
                                  anyOf:
                                    - format: date-time
                                      pattern: >-
                                        ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                      type: string
                                    - type: 'null'
                              required:
                                - id
                                - memoryType
                                - topic
                                - project
                                - scope
                                - status
                                - validFrom
                                - validTo
                                - recordedAt
                                - createdAt
                                - isCurrent
                                - lifecycleState
                              type: object
                          required:
                            - memory
                            - edge
                          type: object
                        type: array
                      truncated:
                        type: boolean
                    required:
                      - predecessors
                      - successors
                      - truncated
                    type: object
                  eventsTruncated:
                    type: boolean
                  lineage:
                    additionalProperties: false
                    properties:
                      edges:
                        items:
                          additionalProperties: false
                          properties:
                            createdAt:
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                              type: string
                            createdBy:
                              enum:
                                - user_dashboard
                                - user_api
                                - user_mcp
                                - worker
                                - importer
                                - system
                              type: string
                            edgeType:
                              enum:
                                - supersedes
                                - updates
                                - extends
                                - derives
                              type: string
                            fromId:
                              format: uuid
                              pattern: >-
                                ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                              type: string
                            id:
                              format: uuid
                              pattern: >-
                                ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                              type: string
                            toId:
                              format: uuid
                              pattern: >-
                                ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                              type: string
                          required:
                            - id
                            - fromId
                            - toId
                            - edgeType
                            - createdBy
                            - createdAt
                          type: object
                        type: array
                      nodes:
                        items:
                          additionalProperties: false
                          properties:
                            createdAt:
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                              type: string
                            id:
                              format: uuid
                              pattern: >-
                                ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                              type: string
                            isCurrent:
                              type: boolean
                            lifecycleState:
                              enum:
                                - current
                                - superseded
                                - archived
                                - historical
                              type: string
                            memoryType:
                              enum:
                                - decision
                                - commitment
                                - blocker
                                - fact
                                - preference
                                - pattern
                                - note
                                - event
                              type: string
                            project:
                              anyOf:
                                - maxLength: 256
                                  minLength: 1
                                  type: string
                                - type: 'null'
                            recordedAt:
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                              type: string
                            scope:
                              maxLength: 64
                              minLength: 1
                              pattern: ^[a-z0-9][a-z0-9-]*$
                              type: string
                            status:
                              enum:
                                - active
                                - archived
                              type: string
                            topic:
                              type: string
                            validFrom:
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                              type: string
                            validTo:
                              anyOf:
                                - format: date-time
                                  pattern: >-
                                    ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                                  type: string
                                - type: 'null'
                          required:
                            - id
                            - memoryType
                            - topic
                            - project
                            - scope
                            - status
                            - validFrom
                            - validTo
                            - recordedAt
                            - createdAt
                            - isCurrent
                            - lifecycleState
                          type: object
                        type: array
                      truncated:
                        type: boolean
                    required:
                      - nodes
                      - edges
                      - truncated
                    type: object
                  memory:
                    additionalProperties: false
                    properties:
                      createdAt:
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                        type: string
                      id:
                        format: uuid
                        pattern: >-
                          ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                        type: string
                      isCurrent:
                        type: boolean
                      lifecycleState:
                        enum:
                          - current
                          - superseded
                          - archived
                          - historical
                        type: string
                      memoryType:
                        enum:
                          - decision
                          - commitment
                          - blocker
                          - fact
                          - preference
                          - pattern
                          - note
                          - event
                        type: string
                      project:
                        anyOf:
                          - maxLength: 256
                            minLength: 1
                            type: string
                          - type: 'null'
                      recordedAt:
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                        type: string
                      scope:
                        maxLength: 64
                        minLength: 1
                        pattern: ^[a-z0-9][a-z0-9-]*$
                        type: string
                      status:
                        enum:
                          - active
                          - archived
                        type: string
                      topic:
                        type: string
                      validFrom:
                        format: date-time
                        pattern: >-
                          ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                        type: string
                      validTo:
                        anyOf:
                          - format: date-time
                            pattern: >-
                              ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d(?::[0-5]\d(?:\.\d+)?)?(?:Z))$
                            type: string
                          - type: 'null'
                    required:
                      - id
                      - memoryType
                      - topic
                      - project
                      - scope
                      - status
                      - validFrom
                      - validTo
                      - recordedAt
                      - createdAt
                      - isCurrent
                      - lifecycleState
                    type: object
                  sections:
                    additionalProperties: false
                    properties:
                      events:
                        enum:
                          - ok
                          - unavailable
                        type: string
                      lineage:
                        enum:
                          - ok
                          - unavailable
                        type: string
                    required:
                      - lineage
                      - events
                    type: object
                required:
                  - memory
                  - lineage
                  - directRelationships
                  - auditEvents
                  - eventsTruncated
                type: object
          description: Success
components:
  securitySchemes:
    apiKey:
      in: header
      name: X-API-Key
      type: apiKey
    sessionBearer:
      scheme: bearer
      type: http

````